#!/usr/bin/env python

###############################################################################
# alatar -- see http://www.esiea-recherche.eu/~desnos/                        #
#                                                                             #
# The project alatar is (C) 2009 : desnos at esiea.fr                         #
# This program is free software;                                              #
# you can redistribute it and/or modify it under the terms of the GNU         #
# General Public License as published by the Free Software Foundation;        #
# Version 2. This guarantees your right to use, modify, and                   #
# redistribute this software under certain conditions.                        #
#                                                                             #
# Source is provided to this software because we believe users have a         #
# right to know exactly what a program is going to do before they run         #
# it.                                                                         #
#                                                                             #
# This program is distributed in the hope that it will be                     #
# useful, but WITHOUT ANY WARRANTY; without even the implied                  #
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                     #
# PURPOSE. See the GNU General Public License for more details (              #
# http://www.gnu.org/copyleft/gpl.html ).                                     #
#                                                                             #
###############################################################################

from logging import (log, info, error, NOTSET, CRITICAL, DEBUG, INFO, WARNING, ERROR)
from log import NOLOG, MyLog
from color import Color

import re, sys, random, os, socket, ctypes, inspect

from linux_struct import stat64, dirent
from ctypes import sizeof, cast, POINTER, c_char_p
from ctypes.util import find_library

from itertools import izip


def ObtainSourceCodeFromSomewhere() :
    return "class Toto :\n"             \
        "\t def __init__(self) :\n"     \
        "\t\tprint \"hello\"\n"         \
        "\t\tself.val = 0\n"            \
        "\t def view(self) :\n"         \
        "\t\tprint \"View : %d\" % self.val\n"          \
        "\t def inc(self, val=1) :\n"          \
        "\t\tself.val += val\n"

import sys, new, xml.parsers.expat, xml.dom.minidom, urllib

class XmlConfig :
    def __init__(self, bufxml, loader) :
        self.bufxml = bufxml
        self.loader = loader
            
        document = xml.dom.minidom.parseString(self.bufxml)
        for item in document.getElementsByTagName('injectmodule'):
            url = ""
            for i in item.getElementsByTagName('url') :
                url += i.firstChild.data + " "

            mtype = item.getElementsByTagName('type')[0].firstChild.data

            info("%sInjecting module : %s%s%s url=%s%s%s type=%s%s%s" % (Color.red, Color.green, item.getAttribute('name'), Color.red, Color.yellow, url, Color.red, Color.yellow, mtype, Color.normal))

            try : 
                module = ""
                for i in item.getElementsByTagName('url') :
                    module += urllib.urlopen(i.firstChild.data).read()
            except IOError, e :
                error("ERROR : " + str(e))
                return

            self.loader.loadingSource(str(item.getAttribute('name')), module)
            

        for item in document.getElementsByTagName('createobject') :
            class_ = item.getElementsByTagName('class')[0].firstChild.data
            module = item.getElementsByTagName('module')[0].firstChild.data

            d = []
            if item.getElementsByTagName('param') :
                if item.getElementsByTagName('typeparam') :
                    typeparam = item.getElementsByTagName('typeparam')[0].firstChild.data.split()
                    lparam = item.getElementsByTagName('param')[0].firstChild.data.split()
                            
                    info("%sCreating object : %s%s%s from class=%s%s%s in module=%s%s%s with param=%s%s%s" % (Color.red, Color.green, item.getAttribute('name'), Color.red, Color.yellow, class_, Color.red, Color.yellow, module, Color.red, Color.yellow, lparam, Color.normal))
                    j = 0
                    for i in typeparam :
                        if i == "int" :
                            lparam[j] = int(lparam[j])
                        elif i == "str" :
                            lparam[j] = str(lparam[j])
                        d.append(lparam[j])

                        j += 1                            

            else :
                info("%sCreating object : %s%s%s from class=%s%s%s in module=%s%s%s" % (Color.red, Color.green, item.getAttribute('name'), Color.red, Color.yellow, class_, Color.red, Color.yellow, module, Color.normal))

            t = self.loader.newObject(str(item.getAttribute('name')), module, class_, d)


            strobj = "%s" % t
            info("%s%s%s" % (Color.purple, strobj, Color.normal))
            

        for item in document.getElementsByTagName('execcfunc') :
            obj = item.getElementsByTagName('obj')[0].firstChild.data

            d = []

            if item.getElementsByTagName('param') :
                info("%sExecuting function : %s%s%s of object=%s%s%s with param=%s%s%s" % (Color.red, Color.green, item.getAttribute('name'), Color.red, Color.yellow, obj, Color.red, Color.cyan, item.getElementsByTagName('param')[0].firstChild.data, Color.normal))
                if item.getElementsByTagName('typeparam') :
                    typeparam = item.getElementsByTagName('typeparam')[0].firstChild.data.split()
                    lparam = item.getElementsByTagName('param')[0].firstChild.data.split()
                            
                    j = 0
                    for i in typeparam :
                        if i == "int" :
                            lparam[j] = int(lparam[j])
                        elif i == "str" :
                            lparam[j] = str(lparam[j])
                        d.append(lparam[j])
                        j += 1

                    self.loader.callFunctionObj(obj, str(item.getAttribute('name')), d)

            else :
                info("%sExecuting function : %s%s%s of object=%s%s%s" % (Color.red, Color.green, item.getAttribute('name'), Color.red, Color.yellow, obj, Color.normal))
                self.loader.callFunctionObj(obj, str(item.getAttribute('name')), d)

class RemoteModule :
    def __init__(self, name) :
        self.name = name
        self.mod = new.module(name)
        
    def setSource(self, source) :
        exec source in self.mod.__dict__

class InsFunc :
    def __init__(self, name) :
        self.arg = []

class InsObj : 
    def __init__(self, name) :
        self.func = {}


class LoadingRemoteModule :
    def __init__(self) :
        self.l = {}
        self.o = {}
        self.inspobj = {}

    def loadingSource(self, name, source) :
        self.l[name] = RemoteModule(name)
        self.l[name].setSource(source)
        sys.modules[name] = self.l[name].mod
        source = ""

    def newObject(self, name, modulename, classname, args) :
        if modulename in self.l :
            module = __import__(modulename)
            class_ = getattr(module, classname)

            newinit = []
            try : 
                arg = inspect.getargspec(class_.__init__)[0]
                arg.pop(0)
                for i in arg :
                    newinit.append(i)
            except AttributeError :
                pass

            i = 0
            
            newargs = izip(newinit, args)

            d = {}
            for i in newargs :
                d[str(i[0])] = i[1]

            obj = class_(**d)
            self.o[name] = obj

            self.inspobj[name] = InsObj(name)
            for fname, value in inspect.getmembers(obj, callable) :
                self.inspobj[name].func[fname] = InsFunc(fname)
#                print value
                arg = inspect.getargspec(value)[0]
                arg.pop(0)
                for i in arg :
                    self.inspobj[name].func[fname].arg.append(i)

            return obj

    def callFunctionObj(self, obj, function, args) :
        newargs = izip(self.inspobj[obj].func[function].arg, args)
                    
        #for arg in self.inspobj[obj].func[function].arg :
        #    print "ARG " + arg

        #print "ARGS " + str(args)

        try :
            d = {}
            for i in newargs :
               # print i
                d[str(i[0])] = i[1]

            func = getattr(self.o[obj], function)
            return func(**d)

        except AttributeError,e :
            error("ERROR : " + str(e))

class SyscallNumber :
    def __init__(self) :
        print "todo"

class SP :
    def __init__(self, _syscall) :
        self._syscall = _syscall

class SyscallOpen(SP) :
    def sp(self, l) :
        name = l[0]
        flags = l[1]
        ret = self._syscall(5, ctypes.c_char_p(name), 0)
        return ["%d" % ret]

class SyscallClose(SP) :
    def sp(self, l) :
        fd = int(l[0])
        ret = self._syscall(6, fd)
        return ["%d" % ret]

class SyscallRead(SP) :
    def sp(self, l) :
        fd = int(l[0])
        size = int(l[1])
        buf = ctypes.create_string_buffer(size)
        ret = self._syscall(3, fd, buf, size)
        return ["%d" % ret, buf]

class SyscallGetuid(SP) :
    def sp(self, l) :
        ret = self._syscall(199)
        return ["%d" % ret]

class SyscallGetcwd(SP) :
    def sp(self, l) :
        size = int(l[0])
        buf = ctypes.create_string_buffer(size)
        ret = self._syscall(183, buf, size)
        return ["%d" % ret, buf]

class SyscallExit(SP) :
    def sp(self, l) :
        status = int(l[0])
        ret = self._syscall(1, status)
        return ["%d" % ret]

class SyscallChdir(SP) :
    def sp(self, l) :
        path = l[0]
        ret = self._syscall(12, path)
        return ["%d" % ret]

class SyscallUnlink(SP) :
    def sp(self, l) :
        path = l[0]
        ret = self._syscall(10, path)
        return ["%d" % ret]

class SyscallFstat(SP) :
    def sp(self, l) :
        fd = int(l[0])
        buf = ctypes.create_string_buffer(sizeof(stat64))
        ret = self._syscall(197, fd, buf)
        mystat = cast(buf, POINTER(stat64))[0]
        return [ buf ]

class SyscallGetdents(SP) :
    def sp(self, l) :
        fd = int(l[0])
        buf = ctypes.create_string_buffer(sizeof(dirent) * 4096)
        ret = self._syscall(220, fd, buf, 4096)
        buf = buf[:ret]

        return [ "%d" % ret, buf ]

class SyscallProxy :
    def __init__(self) :
        info("%sStarting Syscall proxy ...%s" % (Color.red, Color.normal))

        self.libc = ctypes.cdll.LoadLibrary(find_library("c"))
        self._syscall = self.libc.syscall

        self.syscallsproxy = {}

        self.syscallsproxy["open"] = SyscallOpen(self._syscall)
        self.syscallsproxy["read"] = SyscallRead(self._syscall)
        self.syscallsproxy["close"] = SyscallClose(self._syscall)
        self.syscallsproxy["exit"] = SyscallExit(self._syscall)
        self.syscallsproxy["getuid"] = SyscallGetuid(self._syscall)
        self.syscallsproxy["fstat"] = SyscallFstat(self._syscall)
        self.syscallsproxy["getcwd"] = SyscallGetcwd(self._syscall)
        self.syscallsproxy["chdir"] = SyscallChdir(self._syscall)
        self.syscallsproxy["getdents"] = SyscallGetdents(self._syscall)
        self.syscallsproxy["unlink"] = SyscallUnlink(self._syscall)


    def handle(self, l) :
        ret = []
        namesyscall = l[0].lower()

        del l[0]
        if namesyscall in self.syscallsproxy :
            ret = self.syscallsproxy[namesyscall].sp(l)

        return ret

    def sp_open2(self, name, flags) :
        import PyInline

        sp_open_asm = PyInline.build(language="C", code=r"""
        long sp_open_asm(const char *name, int mode)
        {
                long ret;
                printf("name %s %d\n", name, mode);
                asm("push %%eax \n\t"
                    "push %%ebx \n\t"
                    "push %%ecx \n\t"
                    "mov $5, %%eax \n\t"
                    "mov %1, %%ebx\n\t"
                    "mov %2, %%ecx\n\t"
                    "int     $0x80\n\t"
                    "mov %%eax, %0 \n\t"
                    "pop %%ecx \n\t"
                    "pop %%ebx \n\t"
                    "pop %%eax \n\t"
                   :"=m"(ret):"m"(name), "m"(mode));
                return ret;
        }""")

        ret = sp_open_asm.sp_open_asm(name, 0)

class SyscallProxyServer :
    def __init__(self, port) :
        info("%sStarting Syscall proxy server ...%s" % (Color.red, Color.normal))
        self.port = port
        self.sp = None

    def handle(self) :
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s.bind(("localhost", self.port))
        self.s.listen(5)

        while 1 :
            self.conn, self.addr = self.s.accept()

            while 1 :
                data = self.conn.recv(1024)
                if not data: 
                    break

                l = data.split("::")

                if "New" and "SyscallProxy" in l :
                    self.sp = SyscallProxy()
                    self.conn.send("ACK")

                if self.sp != None :
                    ret = self.sp.handle(l)
                    for i in ret :
                        if len(i) > 4096 :
                            j = 0
                            while j < len(i) :
                                self.conn.send(i[j:j+4096])
                                j += 4096
                        else :
                            self.conn.send(i)

            self.conn.close()
            

if __name__ == "__main__" :
    mylog = MyLog()
    mylog.setLevel(INFO)

    if len(sys.argv) == 3 and sys.argv[1] == "-r" :
        lrm = LoadingRemoteModule()
        expr = re.compile("^http://")
        if expr.search(sys.argv[1]) :
            info("%sGetting url %s ...%s" % (Color.blue, sys.argv[2], Color.normal))
            try :
                bufxml = urllib.urlopen(sys.argv[2]).read()
            except IOError, e :
                error("ERROR : " + str(e))
                sys.exit(0)
        else :
            info("%sOpening file %s ...%s" % (Color.blue, sys.argv[2], Color.normal))
            fd = open(sys.argv[2], "r")
            l = fd.readlines()
            fd.close()
            
            bufxml = ""
            for i in l :
                bufxml += i

        XmlConfig(bufxml, lrm)
        info("%sBye bye .....%s" % (Color.blue, Color.normal))

    elif len(sys.argv) == 2 and sys.argv[1] == "-s" :
        port = random.randint(2000, 10000)
        server = SyscallProxyServer(port)
        info("%sBinding random port %s%d%s ...%s" % (Color.blue, Color.yellow, port, Color.blue, Color.normal))
        server.handle()
