from box import *

class BoxRootkit(Box) :
    def add_program(self, args) :
        self.emul = Emulate(False, False)
        if self.filterfiles.only != () :
            self.emul.set_filterfiles(self.filterfiles)

        if self.injectfiles.only != () :
            self.emul.set_injectfiles(self.injectfiles)

        self.program = args

    def filter_resetfiles(self) :
        self.filterfiles.reset()
 
    def filter_files(self, args) :
        for i in args.split() :
            i = i.strip()
            self.filterfiles.add_expr(i)

    def view_filterfiles(self) :
        self.filterfiles.view()

    def inject_resetfiles(self) :
        self.injectfiles.reset()
 
    def inject_file(self, args) :
        self.injectfiles.add_file(args)

    def view_injectfiles(self) :
        self.injectfiles.view()

    def syscallTrace(self, process):
        # First query to break at next syscall

        self.prepareProcess(process)

        while True:
            # No more process? Exit
            if not self.debugger:
                break

            # Wait until next syscall enter
            try:
                event = self.debugger.waitSyscall()
                process = event.process
            except ProcessExit, event:
                self.processExited(event)
                continue
            except ProcessSignal, event:
                event.display()
                process.syscall(event.signum)
                continue
            except NewProcessEvent, event:
                self.newProcess(event)
                continue
            except ProcessExecution, event:
                self.processExecution(event)
                continue

            # Process syscall enter or exit
            self.syscall(process)

    def syscall(self, process):
        state = process.syscall_state
        syscall = state.event(self.syscall_options)

        if process in self.active_syscalls:
            # syscall exit

            # Emulating syscall
            self.emul.emulate_syscall_exit(process, syscall)
     
            del self.active_syscalls[process]
        else:
            # syscall enter

            self.emul.add_syscall(process, syscall, True)
            self.emul.emulate_syscall_enter(process, syscall)
                
            self.active_syscalls[process] = syscall
        # Break at next syscall
        process.syscall()

    def processExited(self, event):
         # Display exit message
        error("*** %s ***" % event)
